<template>
  <div class="WaYoutubeMediaPlayer">
    <div class="container-fluid">
      <div class="row justify-content-center">
        <div class="col-md-10">
          <div
            :class="['responsive-video', { playing }]"
            :style="{ backgroundImage: `url(${dataBackgroundImageSrc})` }"
          >
            <div ref="$player" />
            <div
              v-if="$_cmsSupport_hasContentSlotWithName('duration') || $_cmsSupport_hasContentSlotWithName('title')"
              class="info d-none d-sm-flex"
            >
              <slot name="duration" />
              <slot name="title" />
            </div>
            <button
              v-if="ready"
              class="play"
              type="button"
              @click="playVideo"
            >
              <svg class="icon">
                <use href="#icon-play" />
              </svg>
            </button>
          </div>
          <div
            class="d-sm-none title-mobile"
          >
            <slot name="title" />
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  name: 'WaYoutubeMediaPlayer',
  props: {
    dataBackgroundImageSrc: { type: String, required: true },
    dataYoutubeVideoId: { type: String, required: true },
  },
  data() {
    return {
      initialized: false,
      palyer: null,
      ready: false,
      playing: false,
    }
  },
  mounted() {
    if (typeof window.YT === 'object') {
      this.init();
    } else {
      this.$root.$on('on-you-tube-iframe-apiready', this.init);
      if (typeof window.onYouTubeIframeAPIReady === 'undefined') {
        window.onYouTubeIframeAPIReady = () => {
          this.$root.$emit('on-you-tube-iframe-apiready');
        };
        const tag = document.createElement('script');
        tag.src = this.$store.state.config.apis['get-youtube-script-api'] //'https://www.youtube.com/iframe_api';
        const firstScriptTag = document.getElementsByTagName('script')[0];
        firstScriptTag.parentNode.insertBefore(tag, firstScriptTag);
      }
    }
  },
  beforeDestroy() {
    if (this.player) {
      this.player.stopVideo();
      this.player.destroy();
      this.player = null;
      this.playing = false;
      this.ready = false;
      this.initialized = false;
    }
  },
  methods: {
    init() {
      if (this.initialized) {
        return false;
      }
      this.initialized = true;
      this.player = new window.YT.Player(this.$refs.$player, {
        videoId: this.dataYoutubeVideoId,
        host: 'https://www.youtube-nocookie.com',
        events: {
          'onReady': this.onPlayerReady,
          'onStateChange': this.onPlayerStateChange,
        }
      });
    },
    onPlayerReady() {
      this.ready = true;
    },
    onPlayerStateChange(event) {
      if (event.data === window.YT.PlayerState.ENDED || event.data === window.YT.PlayerState.PAUSED) {
        this.playing = false;
      }
    },
    playVideo() {
      this.player.playVideo();
      this.playing = true;
    }
  }
};
</script>

<style lang="scss" scoped>
  @import "~$scss/_variables";
  @import "~bootstrap/scss/mixins/breakpoints";

  .responsive-video {
    width: 100%;
    background: $color-black no-repeat 50% 50%;
    background-size: cover;
    height: 0;
    padding-bottom: (3 * 100% / 4);
    position: relative;

    &:before {
      content: ' ';
      display: block;
      position: absolute;
      left: 0;
      top: 0;
      width: 100%;
      height: 100%;
      z-index: 1;
      background: rgba($color-black, .5);
    }

    @include media-breakpoint-only(md) {
      height: 590px;
      padding-bottom: 0;
    }

    @include media-breakpoint-up(lg) {
      padding-bottom: (9 * 100% / 16);
    }

    ::v-deep {
      iframe {
        position: absolute;
        left: 0;
        top: 0;
        width: 100%;
        height: 100%;
        z-index: 10;
        opacity: 0;
        transition: opacity .6s ease-in-out;
        pointer-events: none;
      }
    }

    &.playing {
      ::v-deep {
        iframe {
          opacity: 1;
          pointer-events: auto;
        }
      }
    }
  }

  .info {
    position: absolute;
    left: 24px;
    bottom: 24px;
    z-index: 2;
    display: flex;
    align-items: center;

    @include media-breakpoint-up(md) {
      left: 32px;
      bottom: 32px;
    }

    > p {
      margin: 0 0 0 16px;
      position: relative;
      padding-left: 17px;

      &:before {
        content: ' ';
        display: block;
        width: 1px;
        height: 18px;
        background: currentColor;
        position: absolute;
        left: 0;
        top: 50%;
        margin-top: -9px;
      }

      &:first-child {
        margin: 0;
        padding: 0;

        &:before {
          display: none;
        }
      }
    }
  }

  .title-mobile{
    margin-top: 15px;
    /deep/ [class^="typo-"], /deep/ [class^="text-color-"], /deep/ p{
      color:$color-black !important;
    }
  }

  .play {
    position: absolute;
    left: 0;
    top: 0;
    z-index: 5;
    width: 100%;
    height: 100%;
    display: flex;
    align-items: center;
    justify-content: center;
    border: 0;
    padding: 0;
    margin: 0;
    background: none;
    cursor: pointer;
    color: rgba($color-white, .75);

    //font-size: 60px;

    /*@include media-breakpoint-up(md) {
      font-size: 80px;
    }*/

    .icon {
      display: block;
      width: 64px;
      height: 64px;
      fill: rgba($color-white, .75);

      @media (min-width: $bootstrap-sm) {
        width: 96px;
        height: 96px;
      }
    }
  }
</style>